//---------------------------------------------------------------------------
#ifndef BrowseDlgH
#define BrowseDlgH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Dialogs.hpp>
#include <shlobj.h>
//---------------------------------------------------------------------------
typedef enum BrowseFlag{bdBrowseForComputer,bdBrowseForPrinter,
	bdDontGoBelowDomain,bdReturnFsAncestors,bdReturnOnlyFsDirs,
    bdStatusText}TBrowseFlag;
typedef Set<TBrowseFlag,bdBrowseForComputer,bdStatusText>TBrowseFlags;
typedef enum BrowseRoot {
	brRecycleBin, brControlPanel,brDesktop,brDesktopDir,brDrives,
	brFonts,brNetHood,brNetwork,brPersonal,brPrinters,brPrograms,
	brRecent,brSendTo,brStartMenu,brStartUp,brTemplates}TBrowseRoot;

class TBrowseDlg : public TCommonDialog
{
private:
	AnsiString FInitialDir;                         //initial dir to browse from
   TBrowseFlags FOptions;                          //options
   AnsiString FTitle;                         		//Title of the dialog box
   AnsiString FFolderName;                      	//Folder selected by user
   AnsiString FFullPath;									//full path of folder
   AnsiString FStatusText;									//Status text to display
   TBrowseRoot FRoot;										//Root dir
   int FIconIndex;                                 //Icon index in the system
   																//image list

   void __fastcall SetInitialDir(AnsiString Str);
   void __fastcall SetTitle(AnsiString Str);
   void __fastcall SetStatusText(AnsiString Str);
   static int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg,
    									LPARAM lParam,LPARAM lpData);
protected:
public:
	__fastcall TBrowseDlg(TComponent* Owner);
   // __fastcall ~TBrowseDlg();
    void __fastcall Execute();
__published:
	__property AnsiString InitialDir={read=FInitialDir,write=SetInitialDir};
   __property TBrowseFlags Options={read=FOptions,write=FOptions};
   __property TBrowseRoot Root={read=FRoot,write=FRoot};
   __property AnsiString Title={read=FTitle,write=SetTitle};
   __property AnsiString StatusText={read=FStatusText,write=SetStatusText};
   __property AnsiString FolderName={read=FFolderName};
   __property AnsiString FullPath={read=FFullPath};
   __property int IconIndex={read=FIconIndex};
};
//---------------------------------------------------------------------------
#endif
