//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BrowseDlg.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
static inline void ValidCtrCheck(TBrowseDlg *)
{
	new TBrowseDlg(NULL);
}
//---------------------------------------------------------------------------
__fastcall TBrowseDlg::TBrowseDlg(TComponent* Owner)
	: TComponent(Owner)
{
	FInitialDir="";
   FTitle="Select a directory...";
   FOptions.Clear();
   FStatusText="";
   FRoot=brDesktop;
}
//---------------------------------------------------------------------------
namespace Browsedlg
{
	void __fastcall PACKAGE Register()
	{
   	TComponentClass classes[1] = {__classid(TBrowseDlg)};
		RegisterComponents("Leunen", classes, 0);
	}
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::Execute()
{
	LPSTR DisplayName;
   LPITEMIDLIST pidlBrowseReturn,pidlRootFolder;
   BROWSEINFO BrowseInfo;
   LPMALLOC pMalloc;
   int RootDir;

   DisplayName=(char *)malloc(MAX_PATH);

   //Get a pointer to the shell malloc which allocate memory for PIDLs
   if(SHGetMalloc(&pMalloc)==NO_ERROR)
   {
      //Get the Root folder where to browse from
      switch((int)FRoot)
      {
      	case brRecycleBin:			RootDir=CSIDL_BITBUCKET;			break;
         case brControlPanel:			RootDir=CSIDL_CONTROLS;				break;
         case brDesktop:				RootDir=CSIDL_DESKTOP;				break;
         case brDesktopDir:			RootDir=CSIDL_DESKTOPDIRECTORY;	break;
         case brDrives:					RootDir=CSIDL_DRIVES;				break;
         case brFonts:					RootDir=CSIDL_FONTS;					break;
         case brNetHood:				RootDir=CSIDL_NETHOOD;				break;
         case brNetwork:				RootDir=CSIDL_NETWORK;				break;
         case brPersonal:				RootDir=CSIDL_PERSONAL;				break;
         case brPrinters:				RootDir=CSIDL_PRINTERS;				break;
         case brPrograms:				RootDir=CSIDL_PROGRAMS;				break;
         case brRecent:					RootDir=CSIDL_RECENT;				break;
         case brSendTo:					RootDir=CSIDL_SENDTO;				break;
         case brStartMenu:				RootDir=CSIDL_STARTMENU;			break;
         case brStartUp:				RootDir=CSIDL_STARTUP;				break;
         case brTemplates:				RootDir=CSIDL_TEMPLATES;			break;
      }
      //Get the pidl of the Root folder
      if(SHGetSpecialFolderLocation(GetActiveWindow(),
      										RootDir,&pidlRootFolder)==NOERROR)
      {
      	//init BROWSEINFO struct
      	memset(&BrowseInfo,0x00,sizeof(BrowseInfo));
   		BrowseInfo.hwndOwner=GetActiveWindow();
   		BrowseInfo.pidlRoot=pidlRootFolder;
   		BrowseInfo.pszDisplayName=DisplayName;
   		if(FTitle!="")BrowseInfo.lpszTitle=FTitle.c_str();
      	//I've had to use multiple if because there is a bug in BCB1 when using
      	// the ? operator like this :
      	// BrowseInfo.ulFlags=
      	// FOptions.Contains(bdBrowseForComputer)?BIF_BROWSEFORCOMPUTER:0 |
      	// FOptions.Contains(bdBrowseForPrinter)?BIF_BROWSEFORPRINTER:0 |...
      	// and so on...   this always return 1
   		if(FOptions.Contains(bdBrowseForComputer))
      		BrowseInfo.ulFlags=BrowseInfo.ulFlags|BIF_BROWSEFORCOMPUTER;
      	if(FOptions.Contains(bdBrowseForPrinter))
      		BrowseInfo.ulFlags=BrowseInfo.ulFlags|BIF_BROWSEFORPRINTER;
      	if(FOptions.Contains(bdDontGoBelowDomain))
      		BrowseInfo.ulFlags=BrowseInfo.ulFlags|BIF_DONTGOBELOWDOMAIN;
      	if(FOptions.Contains(bdReturnFsAncestors))
      		BrowseInfo.ulFlags=BrowseInfo.ulFlags|BIF_RETURNFSANCESTORS;
         if(FOptions.Contains(bdReturnOnlyFsDirs))
      		BrowseInfo.ulFlags=BrowseInfo.ulFlags|BIF_RETURNONLYFSDIRS;
      	if(FOptions.Contains(bdStatusText))
      		BrowseInfo.ulFlags=BrowseInfo.ulFlags|BIF_STATUSTEXT;
   		BrowseInfo.lpfn=BrowseCallbackProc;
   		BrowseInfo.lParam=(long)this;
      	pidlBrowseReturn=SHBrowseForFolder(&BrowseInfo);	//Browse for folder
      	//PIDL is null if we hit cancel
      	if(pidlBrowseReturn)
      	{
            FIconIndex=BrowseInfo.iImage;				//Get the index of Icon in
            													//system image list
   			FFolderName=DisplayName;					//contains folder selected
   			if(SHGetPathFromIDList(pidlBrowseReturn,DisplayName))
         	{
   			FFullPath=DisplayName;                 //contains full path
         	}
   			free(DisplayName);
            pMalloc->Free(pidlRootFolder);
      		pMalloc->Free(pidlBrowseReturn);
      		pMalloc->Release();
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::SetInitialDir(AnsiString Str)
{
	FInitialDir=Str;
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::SetTitle(AnsiString Str)
{
	FTitle=Str;
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::SetStatusText(AnsiString Str)
{
  	FStatusText=Str;
}
//---------------------------------------------------------------------------
int __stdcall TBrowseDlg::BrowseCallbackProc(HWND hwnd, UINT uMsg,
												LPARAM lParam,LPARAM lpData)
{
	if(uMsg==BFFM_INITIALIZED)
    {
      //Set the status text when the dialog box is displayed
    	SendMessage(hwnd,BFFM_SETSTATUSTEXT,0,
        			(LPARAM)reinterpret_cast<TBrowseDlg *>
					(lpData)->FStatusText.c_str());
      //Set the initial dir if it exists
      SendMessage(hwnd,BFFM_SETSELECTION,TRUE,
      			(LPARAM)reinterpret_cast<TBrowseDlg *>
					(lpData)->FInitialDir.c_str());
    }
    return 0;
}

//---------------------------------------------------------------------------

